using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        //Optionally, you may want to do some stuff right after every mod is loaded
        public static void OnLoad()
        {
            UnityEngine.Debug.Log("Haha");
        }

        //Mods require one of these
        public static void Main()
        {
            CategoryBuilder.Create("Rust Guns", "", ModAPI.LoadSprite("Thumb.png"));


                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"), 
                    NameOverride = "AK", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Rust Guns"), 
                    ThumbnailOverride = ModAPI.LoadSprite("ak.png", 30f), 
                    AfterSpawn = (Instance) => 
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ak.png");
                        Instance.FixColliders();

                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
                        customCartridge.name = "9mm"; 
                        customCartridge.Damage *= 0.3f; 
                        customCartridge.StartSpeed *= 1.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                        customCartridge.Recoil *= 0.7f; 
                        customCartridge.ImpactForce *= 0.7f; 

                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound(""),
                        };

                    }
                }
            );
                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"), 
                    NameOverride = "LR-300", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Rust Guns"), 
                    ThumbnailOverride = ModAPI.LoadSprite("lr300.png", 13f), 
                    AfterSpawn = (Instance) => 
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lr300.png");
                        Instance.FixColliders();

                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
                        customCartridge.name = "9mm"; 
                        customCartridge.Damage *= 0.3f; 
                        customCartridge.StartSpeed *= 1.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                        customCartridge.Recoil *= 0.7f; 
                        customCartridge.ImpactForce *= 0.7f; 

                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound(""),
                        };

                    }
                }
            );
                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"), 
                    NameOverride = "Rust Pistol", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Rust Guns"), 
                    ThumbnailOverride = ModAPI.LoadSprite("pistol.png", 60f), 
                    AfterSpawn = (Instance) => 
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pistol.png");
                        Instance.FixColliders();

                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
                        customCartridge.name = "9mm"; 
                        customCartridge.Damage *= 0.3f; 
                        customCartridge.StartSpeed *= 1.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                        customCartridge.Recoil *= 0.7f; 
                        customCartridge.ImpactForce *= 0.7f; 

                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound(""),
                        };

                    }
                }
            );                    
                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"), 
                    NameOverride = "Rust Revolver", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Rust Guns"), 
                    ThumbnailOverride = ModAPI.LoadSprite("revovler.png", 30f), 
                    AfterSpawn = (Instance) => 
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("revovler.png");
                        Instance.FixColliders();

                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
                        customCartridge.name = "9mm"; 
                        customCartridge.Damage *= 0.3f; 
                        customCartridge.StartSpeed *= 1.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                        customCartridge.Recoil *= 0.7f; 
                        customCartridge.ImpactForce *= 0.7f; 

                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound(""),
                        };

                    }
                }
            );                    
                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Shotgun"), 
                    NameOverride = "Rust Shotgun", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Rust Guns"), 
                    ThumbnailOverride = ModAPI.LoadSprite("shotgun.png", 20f), 
                    AfterSpawn = (Instance) => 
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("shotgun.png");
                        Instance.FixColliders();

                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
                        customCartridge.name = "9mm"; 
                        customCartridge.Damage *= 0.3f; 
                        customCartridge.StartSpeed *= 1.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                        customCartridge.Recoil *= 0.7f; 
                        customCartridge.ImpactForce *= 0.7f; 

                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound(""),
                        };

                    }
                }
            );                    
                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Submachine Gun"), 
                    NameOverride = "Rust Submachine Gun", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Rust Guns"), 
                    ThumbnailOverride = ModAPI.LoadSprite("smg.png", 30f), 
                    AfterSpawn = (Instance) => 
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("smg.png");
                        Instance.FixColliders();

                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
                        customCartridge.name = "9mm"; 
                        customCartridge.Damage *= 0.3f; 
                        customCartridge.StartSpeed *= 1.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                        customCartridge.Recoil *= 0.7f; 
                        customCartridge.ImpactForce *= 0.7f; 

                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound(""),
                        };

                    }
                }
            );                    
                    } 
                }            
            }